/* Fitxer: ExempleClasseGenerica.java
   Descripci: Exemple de disseny i utilitzaci de classe genrica amb 2 tipus genrics.
   Autor: Isidre Guix
*/

import java.util.Date;
import java.awt.Color;

class ExempleClasseGenerica <T1, T2>
{
   private T1 x1;
   private T2 x2;

   public ExempleClasseGenerica (T1 p1, T2 p2)
   {
      x1=p1;
      x2=p2;
   }
   
   public String toString()
   {
      return x1.toString()+" - " +x2.toString();
   }
   
   public T1 getX1() { return x1; }
   
   public T2 getX2() { return x2; }
   
   public static void main (String args[])
   {
      ExempleClasseGenerica <Integer, Float> obj1 = 
         new ExempleClasseGenerica <Integer,Float> (new Integer(20), new Float(42.45));
      ExempleClasseGenerica <Double, Double> obj2 = 
         new ExempleClasseGenerica <Double,Double> (new Double(4.32), new Double(7.45));
      ExempleClasseGenerica obj3 = new ExempleClasseGenerica (new Integer(22), new Date());
      ExempleClasseGenerica obj4 = new ExempleClasseGenerica (50, 'a');
      System.out.println(obj1.toString());
      System.out.println(obj2.toString());
      System.out.println(obj3.toString());
      System.out.println(obj4.toString());
   }
}

