/* Fitxer: TaulaValorsNumerics.java
   Descripci: Exemple complet de classe genrica
   Autor: Isidre Guix
*/

class TaulaValorsNumerics <T extends Number>
{
   private T t[];
   
   public TaulaValorsNumerics (T[] obj) { t = obj; }
   
   public double mitja ()
   {
      double suma=0;
      int valorsNoNuls=0;
      for (int i=0; i<t.length; i++) 
         if (t[i]!=null) 
         {  suma = suma + t[i].doubleValue();
            valorsNoNuls++;
         }
      if (valorsNoNuls==0) return 0;
      else return suma / valorsNoNuls;
   }

   public int dimensio () { return t.length; }
   
   public boolean mateixaMitja (TaulaValorsNumerics <?> obj)
   {
      return mitja() == obj.mitja();
   }
   
   public boolean mateixaDimensio (TaulaValorsNumerics <?> obj)
   {
      return dimensio() == obj.dimensio();
   }

   public String toString()
   {
      String s="{";
      for (int i=0; i<t.length; i++)
         if (s.equals("{")) s = s + t[i];
         else s = s + ", " + t[i];
      s = s + "}";
      return s;
   }

   public static void main (String args[])
   {
      Integer ti[] = {1, 2, null, 3, 4, null, 5};
      Double td[] = {1.1, 2.2, 3.3, null, 4.4, 5.5, 6.6};
      String ts[] = { "Cad1", "Cad2" };
      TaulaValorsNumerics<Integer> tvn1= new TaulaValorsNumerics<Integer> (ti);
      TaulaValorsNumerics<Double> tvn2= new TaulaValorsNumerics<Double> (td);
// Les segents instruccions comentades no sn compilables, ja que el tipus genric T s restringit
//    TaulaValorsNumerics tvn3 = new TaulaValorsNumerics (ts);
//    TaulaValorsNumerics<String> tvn3 = new TaulaValorsNumerics<String> (ts);
      System.out.println("tvn1: "+tvn1);
      System.out.println("   Mitja: "+tvn1.mitja());
      System.out.println("   Dimensi: "+tvn1.dimensio());
      System.out.println("tvn2: "+tvn2);
      System.out.println("   Mitja: "+tvn2.mitja());
      System.out.println("   Dimensi: "+tvn2.dimensio());
      System.out.println("tvn1 i tvn2 tenen la mateixa mitja?    " + tvn1.mateixaMitja(tvn2));
      System.out.println("tvn1 i tvn2 tenen la mateixa dimensi? " + tvn1.mateixaDimensio(tvn2));
   }
}